; PPM 
;5   2 ,
;LCD  16 2     B1602B2 
;  PIC16f78X 
; 1.2a free
;(C)   
;http://radioteh.nm.ru/

;=============================================
        LIST    p=16F873
       __CONFIG 03F39H
;=============================================

INDF        equ        00h         ;     FSR
Timer0      equ        01h         ; TMR0
OptionR     equ        01h         ; Option (RP0=1)
PC          equ        02h         ;  
Status      equ        03h         ; Status
FSR         equ        04h         ;   
PortA       equ        05h         ; Port A
TrisA       equ        05h         ; Tris A - RP0=1
PortB       equ        06h         ; Port B
TrisB       equ        06h         ; Tris B - RP0=1
PortC       equ        07h         ; Port B
TrisC       equ        07h         ; Tris B - RP0=1
PCLATH      equ        0ah         ;
Intcon      equ        0Bh         ;  
Pir1        equ        0Ch
Pie1        equ        0Ch         ;RP=2
Pir2        equ        0Dh 
Pie2        equ        0Dh         ;RP=2
EEData      equ        0Ch         ; EEPROM Data RP=2
EEAdr       equ        0Dh         ; EEPROM Address  RP=2
EECon1      equ        0Ch         ; EECON1 - RP0=3
EECon2      equ        0Dh         ; EECON2 - RP0=3
TMR1L       equ        0Eh         ;
TMR1H       equ        0Fh
T1CON       equ        10h         ;  1
ADRESH      equ        1eh         ; 
ADRESL      equ        1eh         ;  RP0=1, 
ADCON0      equ        1fh         ;. (.,,,/)
ADCON1      equ        1fh         ;. RP0=1, ,

;=============================================
;                                     
W           equ        0           ; 
F           equ        1           ; 
;
;=============================================
; Flag bits:
CF          equ        0           ; Carry
DC          equ        1           ; DC
ZF          equ        2           ; Zero
RP0         equ        5
RP1         equ        6
IRP         equ        7
GoDone      equ        2
;=============================================

bekint      equ        20h             ;  
            cblock      bekint                 ;RBASE
            bekint
            bekstat
            bekpcl
            Temp        
            IntTemp        
            ldCount
            Flags
            Operation
            AD1Hi
            AD1Lo
            AD2Hi
            AD2Lo
            AD3Hi
            AD3Lo
            AD4Hi
            AD4Lo
            AD5Hi
            AD5Lo
            ADHi
            ADLo
            T1
            T2
            T3
            T4
            T5
            T6
            T7
            EADR
            EData
            KS0
            KS1
            KS2
            KbdSc0
            KbdSc1
            KbdSc2
            KbdScOld0
            KbdScOld1
            KbdScOld2
            TzSkan
            Model
            LCDTemp
            LCDTemp1
            LCDTemp2
            MenuPointer
            endc

; 
;      Flags      76543210
;                 1xxxxxxx     
;                 x1xxxxxx     
;                 xx1xxxxx  
;                 xxx1xxxx  
;                 xxxx1xxx  
;                 xxxxx1xx  
;                 xxxxxx1x    
;                 xxxxxxx1   

            ORG        0h
;            call       longdel     
;            call       longdel     
            goto       Start
;********************************************************
;  
;********************************************************
            org        04h             
            movwf      bekint      ; W  
            movf       Status,W    ; 
            clrf       Status      ;  0
            movwf      bekstat         
            bcf        Pir1,0      ;     1
            movf       PCLATH,w
            movwf      bekpcl
            clrf       PCLATH
            movf       Operation,W
            addwf      PC,F        ; W + PC -> PC
            goto       ki 
            goto       sinhro 
            goto       ki 
            goto       kanal1
            goto       ki 
            goto       kanal2
            goto       ki 
            goto       kanal3
            goto       ki 
            goto       kanal4
            goto       ki 
            goto       kanal5     ;Operation= 0
            goto       ki 
            goto       kanal6
            goto       ki 
            goto       kanal7
            goto       ki 
            goto       kanal8     
;;              
EndInt
            movf       bekpcl,W
            movwf      PCLATH  
            movf       bekstat,W
            movwf      Status  
            movf       bekint,W    
            retfie              
;********************************************************
;   
;********************************************************
;   
;********************************************************
Start

            call       lcdinit
           
            call       logo
      
            clrf       Operation
            bsf        Intcon,6    ;    
            bcf        Intcon,7    ;  
            clrf       PortA       ; RA0..RA3 = 0
            bsf        Status,RP0
            movlw      b'11111111'
            movwf      TrisA       ; RA input
            movlw      b'11111000' 
            movwf      TrisB       ; RB 
            movlw      b'00011100' 
            movwf      TrisC       ; 
            bcf        Status,RP0  ;
            clrf       PortB  
            clrf       PortC  
            clrf       TzSkan
            clrf       Flags
            clrf       MenuPointer
            call       kbdclr
;            movlw      80h
;            movwf      T1
;            movwf      T2
;            movwf      T3
;            movwf      T4
;            movwf      T5
;            movwf      T6
;            movwf      T7
;  
            bsf        Status,RP0
            movlw      b'10000000' ;  ,A0-A3,A5  
            movwf      ADCON1       
            bcf        Status,RP0
;    
;            movlw      LCDCLR
;            call       LCDcomd
            clrf       EADR
            call       Read_eeprom
            movwf      Model  
            call       ReadModel


;  1
            movlw      b'00000001' 
            movwf      T1CON
            bsf        Status,RP0
            bsf        Pie1,0      ;    1
            bcf        Status,RP0
            bsf        Intcon,7    ;  
            movlw      00h
            movwf      TMR1L
            movlw      0FFh
            movwf      TMR1H  ;  256 mks


;***************************************************************
;     
;***************************************************************
Main        
            call  SetKBDPort  ;      
            call  Readkbd     ;  
            call  SetLCDPort  ;      LCD 
            btfss Flags,0
            goto  MainMenu

            btfsc Flags,1
            call  MenuU2
            btfss Flags,1
            call  Menu        ;
            goto  Main

 
MainMenu    call  Funktions   ; 

            goto       Main
;***************************************************************
;          
;***************************************************************
;***************************************************************
;    LCD
;***************************************************************
            include   "lcd.inc"       ;    LCD



;***************************************************************
;*                                           *
;*                                   *
;*                                             *
;***************************************************************
Menu

           btfss   KS2,3    
           goto    mf1
           movf    MenuPointer,W ; MenuPointer=14   
           sublw   0DH
           btfss   Status,ZF
           incf    MenuPointer,F

mf1        btfss   KS2,4
           goto    mf2
           movf    MenuPointer,W
           sublw   0H           ; MenuPointer=0   
           btfss   Status,ZF
           decf    MenuPointer,F

mf2        btfsc   KS2,5       ;  select
           bsf     Flags,1     ;    

           btfsc   KS2,6
           goto    MenuOut

             

           btfsc   KS2,7       ;  Save
           nop                 ;   




           movf    MenuPointer,w
           addwf   PC,F        ; W + PC -> PC
           goto    Menu1  
           goto    Menu2  
           goto    Menu3  
           goto    Menu4  
           goto    Menu5  
           goto    Menu6
           goto    Menu7
           goto    Menu8    
           goto    Menu9  
           goto    Menu10  
           goto    Menu11 
           goto    Menu12 
           goto    Menu13 
           goto    Menu14
           goto    Menu15
           goto    Menu16   


Menu1  
            lcdcmd  LCDL2
            movlw   "T"
            call    LCDdata  
            movlw   "R"
            call    LCDdata  
            movlw   "6"
            call    LCDdata  
            movlw   "B"
            call    LCDdata  
            movlw   "e"
            call    LCDdata
            movlw   "g"
            call    LCDdata
            movlw   "i"
            call    LCDdata
            movlw   "n"
            call    LCDdata
  
            goto    endmenu
Menu2
            lcdcmd  LCDL2
            movlw   "T"
            call    LCDdata  
            movlw   "R"
            call    LCDdata  
            movlw   "6"
            call    LCDdata  
            movlw   "E"
            call    LCDdata  
            movlw   "n"
            call    LCDdata  
            movlw   "d"
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            movlw   " "
            call    LCDdata  

            goto    endmenu

Menu3
            lcdcmd  LCDL2
            movlw   "T"
            call    LCDdata  
            movlw   "R"
            call    LCDdata  
            movlw   "7"
            call    LCDdata  
            movlw   "B"
            call    LCDdata  
            movlw   "e"
            call    LCDdata
            movlw   "g"
            call    LCDdata
            movlw   "i"
            call    LCDdata
            movlw   "n"
            call    LCDdata

            goto    endmenu

Menu4
            lcdcmd  LCDL2
            movlw   "T"
            call    LCDdata  
            movlw   "R"
            call    LCDdata  
            movlw   "7"
            call    LCDdata  
            movlw   "E"
            call    LCDdata  
            movlw   "n"
            call    LCDdata  
            movlw   "d"
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            movlw   " "
            call    LCDdata  

            goto    endmenu

Menu5
            lcdcmd  LCDL2
            movlw   "M"
            call    LCDdata  
            movlw   "i"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "s"
            call    LCDdata  
            movlw   "1"
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            movlw   " "
            call    LCDdata  

            goto    endmenu

Menu6
            lcdcmd  LCDL2
            movlw   "M"
            call    LCDdata  
            movlw   "i"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "s"
            call    LCDdata  
            movlw   "2"
            call    LCDdata  

            goto    endmenu

Menu7
            lcdcmd  LCDL2
            movlw   "M"
            call    LCDdata  
            movlw   "i"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "s"
            call    LCDdata  
            movlw   "3"
            call    LCDdata  

            goto    endmenu

Menu8
            lcdcmd  LCDL2
            movlw   "M"
            call    LCDdata  
            movlw   "i"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "s"
            call    LCDdata  
            movlw   "4"
            call    LCDdata
            goto    endmenu  

Menu9
            lcdcmd  LCDL2
            movlw   "M"
            call    LCDdata  
            movlw   "i"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "s"
            call    LCDdata  
            movlw   "5"
            call    LCDdata

            goto    endmenu  

Menu10                     
            lcdcmd  LCDL2
            movlw   "E"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "p"
            call    LCDdata  
            movlw   "1"
            call    LCDdata  
            movlw   " "
            call    LCDdata

            goto    endmenu
Menu11
            lcdcmd  LCDL2
            movlw   "E"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "p"
            call    LCDdata  
            movlw   "2"
            call    LCDdata  

            goto    endmenu
Menu12
            lcdcmd  LCDL2
            movlw   "E"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "p"
            call    LCDdata  
            movlw   "3"
            call    LCDdata  

            goto    endmenu
Menu13
            lcdcmd  LCDL2
            movlw   "E"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "p"
            call    LCDdata  
            movlw   "4"
            call    LCDdata  

            goto    endmenu
Menu14
            lcdcmd  LCDL2
            movlw   "E"
            call    LCDdata  
            movlw   "x"
            call    LCDdata  
            movlw   "p"
            call    LCDdata  
            movlw   "5"
            call    LCDdata  

            goto    endmenu
Menu15
            goto    endmenu
Menu16
            goto    endmenu
Menu17
            goto    endmenu
Menu18
            goto    endmenu
Menu19


endmenu
;  
           clrf      KS0
           clrf      KS1
           clrf      KS2
           return


MenuOut    bcf     Flags,0     ;   e 
           lcdcmd  LCDCLR
           goto    endmenu



MenuU2
            lcdcmd  LCDL2
            movlw   " "
            lcdcmd  LCDL2
            movlw   "M"
            call    LCDdata  
            movlw   "e"
            call    LCDdata  
            movlw   0BDh     ;
            call    LCDdata  
            movlw   0C6h     ;
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            movlw   "U"      ;
            call    LCDdata  
            movlw   "2"      ;
            call    LCDdata  

            btfsc   KS2,6
            bcf     Flags,1     ;     

           return
Funktions
;**************************************************************
; 
;**************************************************************

           btfss   KS0,3        ;T1=T1+1;
           goto    f1
           movf    T1,W         ; ;T1=FF  
           sublw   0FFH
           btfss   Status,ZF
           incf    T1,F
           movlw   T1
           call    Wrtrimers

f1         btfss   KS0,4        ;T2=T2+1;
           goto    f2
           movf    T2,W         ; ;T2=FF  
           sublw   0FFH
           btfss   Status,ZF
           incf    T2,F
           movlw   T2
           call    Wrtrimers

f2         btfss   KS0,5        ;T3=T3+1;
           goto    f3
           movf    T3,W         ; ;T3=FF  
           sublw   0FFH
           btfss   Status,ZF
           incf    T3,F
           movlw   T3
           call    Wrtrimers

f3         btfss   KS0,6        ;T4=T4+1;
           goto    f4
           movf    T4,W         ; ;T4=FF  
           sublw   0FFH
           btfss   Status,ZF
           incf    T4,F
           movlw   T4
           call    Wrtrimers

f4         btfss   KS0,7        ;T5=T5+1;
           goto    f5
           movf    T5,W         ; ;T5=FF  
           sublw   0FFH
           btfss   Status,ZF
           incf    T5,F
           movlw   T5
           call    Wrtrimers

; 
f5         btfss   KS1,3        ;T1=T1-1
           goto    f6
           movf    T1,W
           sublw   0H           ; ;T1=0   
           btfss   Status,ZF
           decf    T1,F
           movlw   T1
           call    Wrtrimers

f6         btfss   KS1,4        ;T2=T2-1
           goto    f7
           movf    T2,W
           sublw   0H           ; ;T2=0   
           btfss   Status,ZF
           decf    T2,F
           movlw   T2
           call    Wrtrimers

f7         btfss   KS1,5        ;T3=T3-1
           goto    f8
           movf    T3,W
           sublw   0H           ; ;T3=0   
           btfss   Status,ZF
           decf    T3,F
           movlw   T3
           call    Wrtrimers

f8         btfss   KS1,6        ;T4=T4-1
           goto    f9
           movf    T4,W
           sublw   0H           ; ;T4=0   
           btfss   Status,ZF
           decf    T4,F
           movlw   T4
           call    Wrtrimers

f9         btfss   KS1,7        ;T5=T5-1
           goto    f10
           movf    T5,W
           sublw   0H           ; ;T5=0   
           btfss   Status,ZF
           decf    T5,F
           movlw   T5
           call    Wrtrimers

; 
f10        btfsc   KS2,3        ;   M+
           call    ModelInc     ; M=+1

           btfsc   KS2,4        ;   M1
           call    ModelDec     ; M=-1

           btfsc   KS2,5        ;
           bsf     Flags,0      ;  

           btfsc   KS2,6        ;  
           bcf     Flags,0      ;   

           btfsc   KS2,7        ;  Save
           call    SaveModel    ;   

;  
kbdclr     clrf      KS0
           clrf      KS1
           clrf      KS2

           return

;   
Wrtrimers
            movwf   LCDTemp2
            movwf   FSR
            call    SetLCDPort  ;      LCD 
            lcdcmd  LCDL2
            movlw   " "
            call    LCDdata  
            movlw   "T"
            call    LCDdata  
            movlw   03h ; T1-30h !!!!!!
            subwf   LCDTemp2,w 
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            movf    INDF,w 
            call    lcdHexByte
            movlw   " "
            call    LCDdata  

            return

;**************************************************************
;
;**************************************************************


SaveModel     ;  
            clrf     EADR
            movwf    Model  
            call     Save_eeprom

            call    CalcADR
            movf    T1,W
            movwf   EData
            call    Save_eeprom
            incf    EADR,F
            movf    T2,W
            movwf   EData
            call    Save_eeprom
            incf    EADR,F
            movf    T3,W
            movwf   EData
            call    Save_eeprom
            incf    EADR,F
            movf    T4,W
            movwf   EData
            call    Save_eeprom
            incf    EADR,F
            movf    T5,W
            movwf   EData
            call    Save_eeprom
            incf    EADR,F


            call  SetLCDPort  ;      LCD 
            lcdcmd  LCDL2
            movlw   " "
            call    LCDdata  
            movlw   "S"
            call    LCDdata  
            movlw   "a"
            call    LCDdata  
            movlw   "v"
            call    LCDdata  
            movlw   "e"
            call    LCDdata  
            movlw   "d"
            call    LCDdata  

            return

ModelInc
            incf    Model,F          ;+1
            goto    ReadModel
ModelDec
            decf    Model,F          ;-1
ReadModel
            call    CalcADR
            call    Read_eeprom
            movwf   T1
            incf    EADR,F
            call    Read_eeprom
            movwf   T2
            incf    EADR,F
            call    Read_eeprom
            movwf   T3
            incf    EADR,F
            call    Read_eeprom
            movwf   T4
            incf    EADR,F
            call    Read_eeprom
            movwf   T5
            incf    EADR,F

IndModel    call  SetLCDPort  ;      LCD 
            lcdcmd  LCDL1
            movlw   "M"
            call    LCDdata  
            movlw   "o"
            call    LCDdata  
            movlw   "d"
            call    LCDdata  
            movlw   "e"
            call    LCDdata  
            movlw   "l"
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            lcdcmd  b'10000110'
            movf    Model,w 
            andlw   b'00001111'
            call    lcdHexByte

 
            return
CalcADR
;     EEPROM  adr=1+*8                                  
           movlw      1
           btfsc      Model,0
           addlw      8H
           btfsc      Model,1
           addlw      10H
           movwf      EADR
           return



;***************************************************************
;    
;***************************************************************
SetKBDPort  ;      
            bsf        Status,RP0
            movlw      b'11111000' 
            movwf      TrisB       ; RB 
            bcf        Status,RP0  ;
            clrf       PortB
            return


Readkbd 
            movf      TzSkan,W
            sublw     0           ;   =0
            btfsc     Status,ZF
            goto      kbd          ;    
            decf      TzSkan,F    ; ,     
            movlw      80h
            movwf      Temp
            call       Pause1
            return
kbd      
            call      kbdScan           ;1 

;  KbdSc= KbdScOld
            movf      KbdSc0,w        ;KbdSc0   
            subwf     KbdScOld0,w
            btfss     Status,ZF
            goto      EndScan
            movf      KbdSc1,w        ;KbdSc1
            subwf     KbdScOld1,w
            btfss     Status,ZF
            goto      EndScan
            movf      KbdSc2,w       ;KbdSc1
            subwf     KbdScOld2,w
            btfss     Status,ZF
            goto      EndScan

;  KbdSc =0.         
            bcf       Flags,7
            movf      KbdSc0,w         ;KbdSc0
            sublw     0
            btfss     Status,ZF
            bsf       Flags,7
            movf      KbdSc1,w         ;KbdSc1
            sublw     0
            btfss     Status,ZF
            bsf       Flags,7
            movf      KbdSc2,w         ;KbdSc1
            sublw     0
            btfss     Status,ZF          
            bsf       Flags,7
            btfss     Flags,7
            return                    ;      
            
            call      kbdScan         ;    

;  KbdSc= KbdScOld
            movf      KbdSc0,w         ;KbdSc0
            subwf     KbdScOld0,w
            btfss     Status,ZF
            goto      EndScan
            movf      KbdSc1,w         ;KbdSc1
            subwf     KbdScOld1,w
            btfss     Status,ZF
            goto      EndScan
            movf      KbdSc2,w         ;KbdSc2
            subwf     KbdScOld2,w
            btfss     Status,ZF
            goto      EndScan

; 
            movf      KbdSc0,w         ;KbdSc0
            movwf     KS0
            movf      KbdSc1,w         ;KbdSc1
            movwf     KS1
            movf      KbdSc2,w         ;KbdSc2
            movwf     KS2
           
            movlw     1fh       ;         
            movwf     TzSkan
;  
            movlw      0fh
            movwf      ldCount
beep      
            bsf        PortC,5
            call       delay
            bcf        PortC,5
            call       delay
            decfsz     ldCount,f
            goto       beep

EndScan   
            movf      KbdSc0,w         ;KbdSc0
            movwf     KbdScOld0
            movf      KbdSc1,w         ;KbdSc1
            movwf     KbdScOld1
            movf      KbdSc2,w         ;KbdSc2
            movwf     KbdScOld2

            return   
            

  ; 
kbdScan    ;   B0
            bsf        PortB,0
            movf       PortB,W
            movwf      KbdSc0
            bcf        KbdSc0,0
            bcf        PortB,0
           ;  B1  
            bsf        PortB,1
            movf       PortB,W
            movwf      KbdSc1
            bcf        KbdSc1,1
            bcf        PortB,1
           ;  B2
            bsf        PortB,2
            movf       PortB,W
            movwf      KbdSc2 
            bcf        KbdSc2,2   
            bcf        PortB,2
            return

;*******************************************************************
;*******************************************************************
;*             PPM                     *
;*     ,    *
;*******************************************************************
;*******************************************************************

ki
            bcf        PortC,0
            bsf        PortC,1        ;        
            movlw      0FFh
            movwf      TMR1H
            movlw      0d7h           ; C8             
            sublw      0ffh
            movwf      TMR1L
            IncF       Operation,F 
            goto   EndInt

sinhro 
            bsf        PortC,0
            bcf        PortC,1

            movlw      0dFh
            movwf      TMR1H
            movlw      00h
            movwf      TMR1L
            IncF       Operation,F 
            Call       ADC         ;  
            goto   EndInt

kanal1                              ;max 07d0 (_f82f)
            bsf        PortC,0
            bcf        PortC,1        ;

            movf       AD1Hi,W
            movwf      ADHi  
            movf       AD1Lo,W
            movwf      ADLo  
            IncF       Operation,F
            movf       T1,W
            goto       KalcKi

kanal2
            bsf        PortC,0
            bcf        PortC,1        ;

            movf       AD2Hi,W
            movwf      ADHi  
            movf       AD2Lo,W
            movwf      ADLo  
            IncF       Operation,F 
            movf       T2,W
            goto       KalcKi


kanal3
            bsf        PortC,0
            bcf        PortC,1        ;
            movf       AD3Hi,W
            movwf      ADHi  
            movf       AD3Lo,W
            movwf      ADLo  
            IncF       Operation,F 
            movf       T3,W
            goto       KalcKi

kanal4
            bsf        PortC,0
            bcf        PortC,1        ;

            movf       AD4Hi,W
            movwf      ADHi  
            movf       AD4Lo,W
            movwf      ADLo  
            IncF       Operation,F 
            movf       T4,W
            goto       KalcKi

kanal5
            bsf        PortC,0
            bcf        PortC,1        ;

            movf       AD5Hi,W
            movwf      ADHi  
            movf       AD5Lo,W
            movwf      ADLo  
            incf       Operation
            movf       T5,W
            goto       KalcKi
            
kanal6
            bsf        PortC,0  ;  
            bcf        PortC,1  ;   
            btfsc      PortC,3  ;  3=0
            goto       $+5

            movlw      0ffh
            movwf      ADHi  
            movlw      03h
            movwf      ADLo  
            goto       $+4

            movlw      00h
            movwf      ADHi  
            movlw      00h
            movwf      ADLo  


            incf       Operation
            movf       T6,W
            goto       KalcKi
            
kanal7
            bsf        PortC,0  ;  
            bcf        PortC,1  ;   
            btfsc      PortC,4  ;  4=0
            goto       $+5

            movlw      0ffh
            movwf      ADHi  
            movlw      03h
            movwf      ADLo  
            goto       $+4

            movlw      00h
            movwf      ADHi  
            movlw      00h
            movwf      ADLo  


            clrf       Operation
            movf       T7,W
            goto       KalcKi

            
kanal8
;  
;  ADLo, ADHi, W
; TMR1L, TMR1H   
KalcKi
            addwf      ADLo,F       ;      
            btfsc      Status,0     ;          
            incf       ADHi,F       ;   
            movf       ADHi,W       ;
            addlw      03h
            sublw      0ffh
            movwf      TMR1H
            movf       ADLo,W
            sublw      0ffh
            movwf      TMR1L
            goto       EndInt

;***************************************************************
;   PPM  
;***************************************************************


;***************************************************************
;    
;***************************************************************

ADC
;   1-5 

            bcf        Status,RP1
;   1- 
                       ;   !!!        ;  
            movlw      b'01000001'    ;  0 
            movwf      ADCON0    
            movlw      10h
            movwf      IntTemp
            call       IntPause         ;    
            bsf        ADCON0,GoDone  ; 
            btfsc      ADCON0,GoDone
            goto       $-1            ;  


;   2- 
                       ;   !!!        ;  
            movlw      b'01001001'    ;  0 
            movwf      ADCON0    

       ;   1- 
            movf       ADRESH,W
            movwf      AD1Hi
            bsf        Status,RP0
            movf       ADRESL,W
            bcf        Status,RP0
            movwf      AD1Lo


            movlw      10h
            movwf      IntTemp
            call       IntPause         ;    
            bsf        ADCON0,GoDone  ; 
            btfsc      ADCON0,GoDone
            goto       $-1            ;  

;   3- 
                       ;   !!!        ;  
            movlw      b'01010001'    ;  0 
            movwf      ADCON0    

       ;   2- 
            movf       ADRESH,W
            movwf      AD2Hi
            bsf        Status,RP0
            movf       ADRESL,W
            bcf        Status,RP0
            movwf      AD2Lo


            movlw      10h
            movwf      IntTemp
            call       IntPause         ;    
            bsf        ADCON0,GoDone  ; 
            btfsc      ADCON0,GoDone
            goto       $-1            ;  


;   4- 
                       ;   !!!        ;  
            movlw      b'01011001'    ;  0 
            movwf      ADCON0    

       ;   3- 
            movf       ADRESH,W
            movwf      AD3Hi
            bsf        Status,RP0
            movf       ADRESL,W
            bcf        Status,RP0
            movwf      AD3Lo


            movlw      10h
            movwf      IntTemp
            call       IntPause         ;    
            bsf        ADCON0,GoDone  ; 
            btfsc      ADCON0,GoDone
            goto       $-1            ;  


;   5- 
                       ;   !!!        ;  
            movlw      b'01100001'    ;  0 
            movwf      ADCON0    

       ;   4- 
            movf       ADRESH,W
            movwf      AD4Hi
            bsf        Status,RP0
            movf       ADRESL,W
            bcf        Status,RP0
            movwf      AD4Lo


            movlw      10h
            movwf      IntTemp
            call       IntPause         ;    
            bsf        ADCON0,GoDone  ; 
            btfsc      ADCON0,GoDone
            goto       $-1            ;  

 
       ;   5- 
            movf       ADRESH,W
            movwf      AD5Hi
            bsf        Status,RP0
            movf       ADRESL,W
            bcf        Status,RP0
            movwf      AD5Lo


            return
;***************************************************************
;   
;***************************************************************

;-------------------------------------
;
;-------------------------------------

; 
Read_eeprom
            movf       EADR,W      ;   
            bsf        Status,6   
            bcf        Status,5  ;  2
            movwf      EEAdr      ;  EEAdr
            bsf        Status,5  
            bcf        EECon1,7
            bsf        EECon1,0 
            bcf        Status,5
            movf       EEData,W
            bcf        Status,6
            return

;  
Save_eeprom
            bsf        Status,RP1
            bsf        Status,RP0  ;  3
            btfsc      EECon1,1 
            goto       $-1
            bcf        Status,RP1
            bcf        Status,RP0  ;  0
            movf       EADR,W      ;   
            bsf        Status,RP1
            movwf      EEAdr      ;  EEAdr
            bcf        Status,RP1 ; 0
            movf       EData,W
            bsf        Status,RP1
            movwf      EEData      ;  EEAdr
            bsf        Status,RP1
            bsf        Status,RP0  ;  3
            bcf        EECon1,7
            bsf        EECon1,2 
            bcf        Intcon,7   ; 
            movlw      55h            
            movwf      EECon2
            movlw      0aah
            movwf      EECon2
            bsf        EECon1,1
            bsf        Intcon,7   ; 
            bcf        EECon1,3
            bcf        Status,RP1
            bcf        Status,RP0 ;  0
            return
;    
longdel     
            movlw      0ffh
            movwf      ldCount
Pause0      
            call       delay
            decfsz     ldCount,f
            goto       Pause0
            return      
; 
delay                              ;515
            movlw      0ffh
            movwf      Temp
Pause1
            decfsz     Temp,F
            goto       Pause1
            return

; .   
IntPause
            decfsz     IntTemp,F
            goto       IntPause
            return

; 
logo        
 
            

            lcdcmd      LCDCLR
;           call       longdel     


            lcdcmd  LCDL1
            movlw   "r"
            call    LCDdata  
            movlw   "a"
            call    LCDdata  
            movlw   "d"
            call    LCDdata  
            movlw   "i"
            call    LCDdata  
            movlw   "o"
            call    LCDdata  
            movlw   "t"
            call    LCDdata  
            movlw   "e"
            call    LCDdata  
            movlw   "h"
            call    LCDdata  
            movlw   "."
            call    LCDdata  
            movlw   "n"
            call    LCDdata  
            movlw   "m"
            call    LCDdata  
            movlw   "."
            call    LCDdata  
            movlw   "r"
            call    LCDdata  
            movlw   "u"
            call    LCDdata  
            movlw   " "
            call    LCDdata  
            movlw   " "
            call    LCDdata  


            lcdcmd  LCDL2

            movlw   "("        ;1
            call    LCDdata  
            movlw   "C"        ;2
            call    LCDdata  
            movlw   ")"        ;14
            call    LCDdata  
            movlw   " "        ;15
            call    LCDdata  
            movlw   0A7h        ;
            call    LCDdata  
            movlw   0C3h        ;
            call    LCDdata  
            movlw   0BFh        ;
            call    LCDdata    
            movlw   0BDh        ;
            call    LCDdata  
            movlw   0B5h        ;
            call    LCDdata  
            movlw   0B3h        ;
            call    LCDdata  
            movlw   " "        ;9
            call    LCDdata  
            movlw   0A5h        ;10
            call    LCDdata  
            movlw   "."        ;11
            call    LCDdata  
            movlw   "B"        ;12
            call    LCDdata  
            movlw   "."        ;13
            call    LCDdata  
            movlw   " "        ;16
            call    LCDdata  



            call       longdel     
            call       longdel     
            call       longdel     
            call       longdel     
            call       longdel     
            call       longdel     
            call       longdel     
            call       longdel     
            call       longdel     

            lcdcmd      LCDCLR
            return

            org        2100h

            de    00h
            de    7fh
            de    7fh
            de    7fh
            de    7fh
            de    7fh
            de    7fh

            end
